import { Module } from '@nestjs/common';
import { FisFingerprintController } from './fis-fingerprint.controller';
import { FisFingerprintService } from './fis-fingerprint.service';
import { ClientsModule, Transport } from '@nestjs/microservices';
import { ConfigModule, ConfigService } from '@nestjs/config';
import configuration from '../../../config/configurations';
import 'dotenv/config'
@Module({
  imports: [
    ConfigModule.forRoot({
      isGlobal: true,
      load: [configuration]
    }),
    ClientsModule.registerAsync([
      {
        name: `SAMPLEAPP_SERVICE`,
        imports: [ConfigModule],
        useFactory: async (configService: ConfigService) => ({
          transport: Transport.TCP,
          options: {
            host: configService.get<string>(`sampleApp.host`) as string,
            port: configService.get<number>(`sampleApp.tcpPort`) as number
          }
        }),
        inject: [ConfigService]
      },
    ])
  ],
  controllers: [FisFingerprintController],
  providers: [FisFingerprintService],
})
export class FisFingerprintModule { }
