import { Inject, Injectable } from '@nestjs/common';
import { ClientProxy } from '@nestjs/microservices';

@Injectable()
export class SampleAppService {

  constructor(
    @Inject(`FINGERPRINT_SERVICE`) private fingerprintClient: ClientProxy,
    @Inject(`VERIFICATION_SERVICE`) private verificationClient: ClientProxy
  ) {
    // logic here
  }

  getHello(): string {
    return 'Hello World! I am Sample App Nestjs.';
  }

  // testing. Try to talk to Fingerprint App via microservice
  talkToFingerprint(message: string): any {
    this.fingerprintClient.emit<string>(`eventTest`, message)
    this.verificationClient.emit<string>(`eventTest`, message)
    return this.fingerprintClient.send<string>({ cmd: `messageTest` }, message)
  }


}
